import { gsap } from 'gsap';
import { ScrollToPlugin } from "gsap/ScrollToPlugin";
import { ScrollTrigger } from "gsap/ScrollTrigger";
import { windowsize } from '../utils/utilities';

export default class header  {
    constructor() {
        /*
            si queremos que la clase sea de una seccion ponemos a la clase el nombre del class del <section class="module1"></section>
        */
        this.renderer = arguments[0];
        const name_ = this.constructor.name;
        this.section_ = document.querySelector ("."+name_);
        if (!this.section_) return;
        this.createElements ();
        /* ******************************* */

        this.menuopen = false;
        this.fromto = "desk2mob";

        gsap.registerPlugin(ScrollToPlugin);
        gsap.registerPlugin(ScrollTrigger);
  
        //window.onresize = this.resize.bind (this);
        this.renderer.addResizer (this.resize, this);
        
    }

    createElements () {
        this.burger_ = document.querySelector (".burger");

        this.ham1_ = document.querySelector ("#ham1");
        this.ham2_ = document.querySelector ("#ham2");
        this.ham3_ = document.querySelector ("#ham3");

        this.burger_.addEventListener ("click", () => {
            this.openCloseMobileMenu ();
        })

        this.menu_mobile_ = document.querySelector (".menu_mobile");

        let menu_ = document.querySelector (".menu_desktop");
        menu_.querySelectorAll('a[href]').forEach(a => {
          a.addEventListener('click', e => {
            console.log (a);
            this.scrollToHash(this.getSamePageAnchor(a), e);
          });
        });

        let menu_mobile_ = document.querySelector (".menu_mobile");
        menu_mobile_.querySelectorAll('a[href]').forEach(a => {
          a.addEventListener('click', e => {
            this.scrollToHash(this.getSamePageAnchor(a), e);
            this.openCloseMobileMenu ();
          });
        });
    }

    init () {
        if (!this.section_) return;
        console.log ("Init del section: " + this.constructor.name);
    }

    scrollToHash(hash, e) {
      const elem = hash ? document.querySelector(hash) : false;
      if(elem) {
          if(e) e.preventDefault();
          gsap.to(window, {scrollTo: elem});
      }
    }

    getSamePageAnchor (link) {
      if (
        link.protocol !== window.location.protocol ||
        link.host !== window.location.host ||
        link.pathname !== window.location.pathname ||
        link.search !== window.location.search
      ) {
        return false;
      }
      return link.hash;
    }

    openCloseMobileMenu () {
        this.menuopen = (this.menuopen)?false:true;
  
        gsap.killTweensOf (this.menu_mobile_);
        if (this.menuopen) {
          gsap.to (this.ham1_, {  duration: .15, rotation: 45, x:2, y: -5  });
          gsap.to (this.ham2_, {  duration: .15, opacity: 0 });
          gsap.to (this.ham3_, {  duration: .15, rotation: -45, x: 5 });
  
          const complete_ = () => { 
            document.body.style.overflowY = 'hidden'; 
          };
          
          gsap.set (this.menu_mobile_, { visibility : "visible"});
          gsap.to (this.menu_mobile_, {  duration: .5, opacity: 1, onComplete: complete_});
        } else {
          gsap.to (this.ham1_, {  duration: .15, rotation: 0, y: 0, x: 0 });
          gsap.to (this.ham2_, {  duration: .15, opacity: 1 });
          gsap.to (this.ham3_, {  duration: .15, rotation: 0, x: 0 });
          
          const complete_ = () => { 
            gsap.set (this.menu_mobile_, { visibility : "hidden"}); 
            document.body.style.overflowY = 'auto';
        };
          gsap.to (this.menu_mobile_, {  duration: .5, opacity: 0, onComplete: complete_ });
        }
    }

    resize () {
        document.documentElement.scrollLeft = 0;

        let dW_ = windowsize().w;
		let dH_ = windowsize().h;

        if (dW_ <= 768) {
          if (this.fromto == "desk2mob") {
            //console.log ("Pasamos a mobile")
            this.fromto = "mov2desk";
            this.setMobile2Desktop ("desk2mob");
            if (this.menuopen) {
              gsap.to (this.menu_mobile_, { visibility : "visible"});
              document.body.style.overflowY = 'hidden'; 
            } else {
              gsap.to (this.menu_mobile_, { visibility : "hidden"});
              document.body.style.overflowY = 'auto'; 
            }
          }
        } else {
          if (this.fromto == "mov2desk") {
            //console.log ("Pasamos a desktop")
            this.fromto = "desk2mob";
            this.setMobile2Desktop ("mob2desk");
            gsap.to (this.menu_mobile_, { visibility : "hidden"});
            document.body.style.overflowY = 'auto'; 
          }
        }
    }

    setMobile2Desktop (fromto) { 

    }
}