import { gsap } from 'gsap';
import { ScrollToPlugin } from "gsap/ScrollToPlugin";
import { ScrollTrigger } from "gsap/ScrollTrigger";
import { windowsize } from '../utils/utilities';

export default class ideasconsejos  {
    constructor() {
        this.opcActiva = 1;
        /*
            si queremos que la clase sea de una seccion ponemos a la clase el nombre del class del <section class="module1"></section>
        */
        this.renderer = arguments[0];
        const name_ = this.constructor.name;
        this.section_ = document.querySelector ("."+name_);
        if (!this.section_) return;
        this.createElements ();
        /* ******************************* */

        
    }

    createElements () {
        console.log ("creamos selectores del section:" + this.constructor.name);

        this.selector_ = this.section_.querySelector (".selector")
            this.rollover_ = this.section_.querySelector (".rollover")

        this.opts_ = this.section_.querySelectorAll (".opc")
        this.opts_.forEach(oc => {
            oc.addEventListener ("click", (e)=> {
                let e_ = e.currentTarget;
                this.setSelector (e_);
            })            
        });

        this.cajas_ = this.section_.querySelectorAll (".mini");

        this.vermas_ = this.section_.querySelector (".vermas");
        this.vermas_.addEventListener ("click", ()=> {
            this.viewMore ();
        });

        setTimeout(() => {
            this.setSelector (this.opts_[this.opcActiva-1]);
        }, 150);
        
        
        //window.onresize = this.resize.bind (this);
        this.renderer.addResizer (this.resize, this);
    }

    init () {
        if (!this.section_) return;

        console.log ("Init del section: " + this.constructor.name);
    }

    setSelector (e_) {
        this.opts_.forEach(oc => {gsap.to (oc, { color: "#29343A" }); });
        this.opcActiva = e_.getAttribute ("data-num");
        
        gsap.to (e_, { color: "white" })
        gsap.to (this.rollover_, { duration:.5, width: e_.offsetWidth+20, left:e_.offsetLeft-10, top:e_.offsetTop-7, height: e_.offsetHeight+14 });

        this.setCategories (e_);
    }

    setCategories (e_) {
        this.catSelected = e_.getAttribute ("data-cat");
        
        this.myVisibles = [];
        this.maxVisibles = 4;
        this.numVisibles = 0;
        
        this.cajas_.forEach(el => {
            gsap.set (el, { display: "none"});
        });

        if (this.catSelected == "todas") {
            this.cajas_.forEach(el => { 
                //gsap.set (el, { display: "block"});
                this.myVisibles.push (el);
            });
        } else {
            this.cajas_.forEach(el => {
                let cat_ = el.getAttribute ("data-cat");
                if (cat_.indexOf(this.catSelected)>-1) {
                    //gsap.set (el, { display: "block"});
                    this.myVisibles.push (el);
                } else {
                    //gsap.set (el, { display: "none"});
                }
            });
        }

        this.setVisible ();
    }

    setVisible () {
        this.numVisibles = 0;
        this.myVisibles.forEach(el => {
            if (this.numVisibles < this.maxVisibles) {
                gsap.set (el, { display: "block"});
            }
            this.numVisibles++;
        });

        if (this.numVisibles <= this.maxVisibles) {
            gsap.set (this.vermas_, { display: "none" });
        } else {
            gsap.set (this.vermas_, { display: "flex" });
        }
    }

    viewMore () {
        this.maxVisibles+=4;
        this.setVisible ();
        
        if (this.numVisibles <= this.maxVisibles) {
            gsap.set (this.vermas_, { display: "none" });
        } else {
            gsap.set (this.vermas_, { display: "flex" });
        }
    }

    resize () {
        let e_ = this.opts_[this.opcActiva-1];
        gsap.set (this.rollover_, { width: e_.offsetWidth+20, left:e_.offsetLeft-10, top:e_.offsetTop-7, height: e_.offsetHeight+14 });
    }
}