// import Swiper bundle with all modules installed
import Swiper from 'swiper/bundle';

// import styles bundle
import 'swiper/css/bundle';


export default class webinars  {
    constructor() {
        /*
            si queremos que la clase sea de una seccion ponemos a la clase el nombre del class del <section class="module1"></section>
        */
        this.renderer = arguments[0];
        const name_ = this.constructor.name;
        this.section_ = document.querySelector ("."+name_);
        if (!this.section_) return;
        this.createElements ();
        /* ******************************* */
    }

    createElements () {
        console.log ("creamos selectores del section:" + this.constructor.name);
    }

    init () {
        if (!this.section_) return;
        

        console.log ("Init del section: " + this.constructor.name);

        this.initSwiper();
        //this.renderer.connect ("cabeceras").getCabeceras ();
        this.renderer.addResizer (this.resize, this);
        
        setTimeout(() => {
            this.resize ();    
        }, 10);
        
    }

    resize () {
        var swiper__slidecount = this.swiper.slides.length;
        if (this.swiper.isBeginning && this.swiper.isEnd) {
            this.$btnPrev.classList.add ("disableBot");
            this.$btnNext.classList.add ("disableBot");
        } else {
            this.$btnPrev.classList.remove ("disableBot");
            this.$btnNext.classList.remove ("disableBot");
        }
    }



    initSwiper () {

        this.swiper = new Swiper(this.section_.querySelector('.swiper'), {
            slidesPerView: 1,
            slidesPerGroup: 1,
            spaceBetween: 18,
            breakpoints: {
                640: {
                    slidesPerView: 2,
                    spaceBetween: 18,
                    slidesPerGroup: 2
                },
                1024: {
                    slidesPerView: 3,
                    spaceBetween: 18,
                    slidesPerGroup: 3
                }
            },
            pagination: {
                el: this.section_.querySelector('.swiper-pagination'),
                clickable: true,
                // dynamicBullets: true
              }
        });

        this.$btnPrev = this.section_.querySelector('.swiper-prev');
        this.$btnNext = this.section_.querySelector('.swiper-next');


        this.$btnPrev.addEventListener('click', ()=>{
            this.swiper.slidePrev();
        });
        this.$btnNext.addEventListener('click', ()=>{
            this.swiper.slideNext();
        });
    }
}