import Rushmore from "../Rushmore";
import { eD as eleDOM } from '../eleDOM.js';

import Player from '@vimeo/player';


class DialogBox {

    constructor() {
        this.rush_ = new Rushmore ();
        this.rush_.addResizer (this.onresize, this);
        this.dialog = this.rush_.create ("#dialog");
        this.closeDial = this.rush_.create ("#closeDial");
        this.messageDial  = this.rush_.create ("#messageDial");

        this.idVideo = 0;

        this.closeDial.addEventListener('click', (e) => {this.fadeOut () });

        this.playBot_ = this.rush_.create ("#playRRSS");
        this.playBot_.addEventListener ("click", ()=> {
          this.playIt ();
        });
              
      this.bigtransparent_ = this.rush_.create ("#bigtransparent");
      this.bigtransparent_.addEventListener ("click", ()=> {
        this.fadeOut () 
      }); 
    }

    writeMSG (t) {
        this.messageDial.innerHTML = t;
        this.onresize ();
    }

    fadeOut(){
       var d = this.dialog;
       eleDOM.setStyles(d, {opacity: 1});
       
       this.stopRRSS ();

        (function fade() {
          var val = eleDOM.getStyle (d, "opacity");
          if ((val -= .1) < 0) {
            eleDOM.setStyles(d, {visibility: "hidden"});
          } else {
            eleDOM.setStyles(d, {opacity: val});
            requestAnimationFrame(fade);
          }
        })();
    }
      
    fadeIn(v_){
        var d = this.dialog;
        eleDOM.setStyles(d, {opacity: 0});

        this.idVideo = v_;
        this.playRRSS ();

        (function fade() {
          var val = parseFloat(eleDOM.getStyle (d, "opacity"));
          if (!((val += .1) > 1)) {
            eleDOM.setStyles(d, {opacity: val, visibility: "visible"});
            requestAnimationFrame(fade);
          }
        })();
    }    
    
    playIt () {
       this.player.play ();
       eleDOM.hide(this.playBot_);
    }

    playRRSS () {
      if (!this.player) {
        this.player = new Player('videoRRSS', {});
        this.player.on("loaded", ()=> { this.loadVideo (); });
      } else this.loadVideo ();
    }

    loadVideo () {
      console.log (String (this.idVideo))
      this.player.loadVideo("https://player.vimeo.com/video/" + String (this.idVideo) + "?background=1&autoplay=0").then(()=> {  
          eleDOM.show(this.playBot_);    
          this.player.setVolume(1);  
      });
    }

    stopRRSS () {
      console.log ("stop al video");
      this.player.pause ();
      
    }

    onresize () {
      let t_ = this.messageDial.scrollHeight;
      eleDOM.setStyles(this.messageDial, {top: Number (-t_/2)});
    }

}

export default new DialogBox();

