import Rushmore from "../Rushmore";
import { eD as eleDOM } from '../eleDOM.js';

import displace from 'displacejs';
import Regla from "./Regla";

export default class DragBarUtil {

    constructor(ft_, ori_, funct_, value_) {
      this.rush_ = new Rushmore ();
      this.rush_.addResizer (this.onresize, this);

      this.father = ft_;
      this.orientacion = ori_;
      this.callback = funct_;
      this.retorno = value_;

      this.createElements ();

      this.dragBar ();
    }

      /*  Creacion de los elementos htmls a usar */
    createElements () { 
      this.dragdrop = this.rush_.create ("#" + this.father + " .dragdropSCR");
      this.bounds = this.rush_.create ("#" + this.father + " .boundsSCR");     
    }

    dragBar () {
      if (this.orientacion == "horizontal") {
        this.longitud = parseInt(eleDOM.getStyle (this.bounds, "width")) - parseInt(eleDOM.getStyle (this.dragdrop, "width"));
      } else  {
          if (this.orientacion == "vertical") {
            this.longitud = parseInt(eleDOM.getStyle (this.bounds, "height")) - parseInt(eleDOM.getStyle (this.dragdrop, "height"));
          }
      }
      //Regla DragBar
      this.rscr = new Regla (0,this.longitud, this.retorno);
    
      this.options = {
        constrain: true,
        relativeTo: this.bounds,
    
        onMouseDown: this.strSCR.bind(this),
        onMouseUp: this.stpSCR.bind(this),
        onMouseMove: this.moveSCR.bind(this),
        onTouchMove:this.moveSCR.bind(this)
      };
    
      this.drdisplace = displace(this.dragdrop, this.options);
    }

    newDataRule (v_) {
      this.retorno = v_;
      this.rscr.newData (0, this.longitud, this.retorno );
    }
    
    strSCR () {}
    stpSCR () {}

    moveSCR () {
      let offset = (this.orientacion == "horizontal")?this.dragdrop.offsetLeft:this.dragdrop.offsetTop;
      this.value = (this.rscr.get_hallar (offset));
      this.callback (this.value);
    }

    onresize () {
     
    }

}

